library circle;

import 'point.dart';
import '../vectors/vector.dart';
import '../vectors/doublevector.dart';

abstract class Abstract2DCircle<N extends num> extends Abstract2DPoint<N> {
	N get radius;
	N get diameter => 2 * radius;

	N get leftX => x - radius;
	N get rightX => x + radius;
	N get topY => y + radius;
	N get bottomY => y - radius;

	set leftX( N value ) => position.x = value + radius;
	set rightX( N value ) => position.x = value - radius;
	set topY( N value ) => position.y = value + radius;
	set bottomY( N value ) => position.y = value - radius;
}


class CustomDouble2DCircle extends Abstract2DCircle<double> {
	final Abstract2DVector<double> _position = new CustomDouble2DVector( 0.0, 0.0 );
	double _radius = 1.0;

	Abstract2DVector<double> get position => _position;
	double get radius => _radius;
}