library planes;

abstract class AbstractHalfPlane<N extends num> {
	N get a;
	N get b;
	N get c;
}


abstract class OrthogonalDoubleHalfPlane extends AbstractHalfPlane<double> {
	double _distance;

	OrthogonalDoubleHalfPlane( this._distance );
}


class LeftOrthogonalDoubleHalfPlane extends OrthogonalDoubleHalfPlane {
	LeftOrthogonalDoubleHalfPlane( double distance ) : super( distance );

	double get a => 1.0;
	double get b => 0.0;
	double get c => _distance;
}

class RightOrthogonalDoubleHalfPlane extends OrthogonalDoubleHalfPlane {
	RightOrthogonalDoubleHalfPlane( double distance ) : super( distance );

	double get a => -1.0;
	double get b => 0.0;
	double get c => _distance;
}

class TopOrthogonalDoubleHalfPlane extends OrthogonalDoubleHalfPlane {
	TopOrthogonalDoubleHalfPlane( double distance ) : super( distance );

	double get a => 0.0;
	double get b => 1.0;
	double get c => _distance;
}

class BottomOrthogonalDoubleHalfPlane extends OrthogonalDoubleHalfPlane {
	BottomOrthogonalDoubleHalfPlane( double distance ) : super( distance );

	double get a => 0.0;
	double get b => 1.0;
	double get c => _distance;
}


class CustomDoubleHalfPlane extends AbstractHalfPlane<double>{
	double _a, _b, _c;

	double get a => _a;
	double get b => _b;
	double get c => _c;

	void set( a, b, c ) {
		_a = a;
		_b = b;
		_c = c;
	}
}